#include <bits/stdc++.h>

using namespace std;

/**
    Problem        : Chimichangas
    Algorithm      : dynamic programming in O(min(W, K * N) * K * N)
    Expected score : 20p (it should NOT be 45p)
    Author         : Alexandru Valeanu
**/

const int MAX_N = 10000;
const int MAX_K = 10000;
const int MAX_W = 10000;
const int MAX_C = 10000;

const int MOD = 2999;

short dp[MAX_W + 1][MAX_K + 1];
int calory[MAX_N + 1];

int N, K;
int Q;

void addMod(short &a, short b)
{
    a = a + b;

    if (a >= MOD)
        a -= MOD;
}

int main()
{
    ifstream in("chimichangas.in");
    ofstream out("chimichangas.out");

    in >> N >> K;

    for (int i = 0; i < N; ++i)
        in >> calory[i];

    int maxC = *max_element(calory, calory + N);
    const int LIMIT = maxC * K;

    dp[0][0] = 1;

    for (int i = 0; i < LIMIT; ++i)
        for (int j = 0; j < K; ++j)
            if (dp[i][j]) ///optimization
            {
                for (int p = 0; p < N; ++p)
                    if (i + calory[p] <= LIMIT) ///out of bounds check ?
                        addMod(dp[i + calory[p]][j + 1], dp[i][j]);
            }

    in >> Q;

    while (Q--)
    {
        int weight;
        in >> weight;

        if (weight > LIMIT)
            out << "0\n";
        else
            out << dp[weight][K] << "\n";
    }

    in.close();
    out.close();
}
