#include <bits/stdc++.h>

using namespace std;

/**
    Problem        : Chimichangas
    Algorithm      : dynamic programming in O(W * K * N) + particular test (Subtask 2)
    Expected score : 25p
    Author         : Alexandru Valeanu
**/

const int MAX_N = 100000;
const int MAX_K = 10;
const int MAX_W = 2000;
const int MAX_C = 500;

const int MOD = 2999;

short dp[MAX_W + 1][MAX_K + 1];
int calory[MAX_N + 1];

int N, K;
int Q;

void addMod(short &a, short b)
{
    a = a + b;

    if (a >= MOD)
        a -= MOD;
}

int main()
{
    ifstream in("chimichangas.in");
    ofstream out("chimichangas.out");

    in >> N >> K;

    for (int i = 0; i < N; ++i)
        in >> calory[i];

    in >> Q;

    if (K == 2 && Q <= 100)
    {
        set<int> seen;

        for (int i = 0; i < N; ++i)
            seen.insert(calory[i]);

        while (Q--)
        {
            int weight;
            in >> weight;

            int sol = 0;

            for (int i = 0; i < N; ++i)
            {
                if (seen.find(weight - calory[i]) != seen.end())
                    sol++;
            }

            out << sol % MOD << "\n";
        }

        return 0;
    }

    dp[0][0] = 1;

    for (int i = 0; i < MAX_W; ++i)
        for (int j = 0; j < K; ++j)
            if (dp[i][j]) ///optimization
            {
                for (int p = 0; p < N; ++p)
                    if (i + calory[p] <= MAX_W) ///out of bounds check ?
                        addMod(dp[i + calory[p]][j + 1], dp[i][j]);
            }

    while (Q--)
    {
        int weight;
        in >> weight;

        out << dp[weight][K] << "\n";
    }

    in.close();
    out.close();
}
